/*
 * lab03a_calc.c
 *
 *  Created on: 17 Mar 2015
 *      Author: Voroshazi Zs. / Varga L.
 *  
 *
 */

#include "xparameters.h"
#include "xgpio.h"
#include "led_ip.h"
//-------------------------
int main (void){
	XGpio dip, push;
	u32 psb_check, dip_check;
	u32 dip_check_A = 0;
	u32 dip_check_B = 0;
	int ok = 1;
	int res = 0;


	//printf("-- Start of the Lab03a Program --\r\n");
	xil_printf("-- Start of the Lab03a Calculator Program --\r\n");
	//int XGpio_Initialize(XGpio *InstancePtr, u16 DeviceId);
	if (XGpio_Initialize(&dip, XPAR_DIP_DEVICE_ID) != XST_SUCCESS){
		xil_printf("Dip Switches initialisation error!\r\n");
	} else {
		xil_printf("Dip Switches initialised successfully!\r\n");
	}

	if (XGpio_Initialize(&push, XPAR_PB_DEVICE_ID)!= XST_SUCCESS){
		xil_printf("Push Buttons initialisation error!\r\n");
	} else {
		xil_printf("Push Buttons initialised successfully!\r\n");
	}

	//void XGpio_SetDataDirection(XGpio *InstancePtr, unsigned Channel, u32 DirectionMask);
	XGpio_SetDataDirection(&dip, 1, 0xFFFFFFFF);
	XGpio_SetDataDirection(&push, 1, 0xFFFFFFFF);

	xil_printf("Note: Addition    [+]: PB[2:0]=000\r\n ");
	xil_printf("      Subtraction [-]: PB[2:0]=001\r\n "); 
	...
	xil_printf("      Exit           : PB[2:0]=100\r\n ");
	xil_printf("-------------------------------------------------\r\n");
	xil_printf("Initial value of result = %d\r\n", res);
	while(psb_check != 0x4){
		//u32 XGpio_DiscreteRead(XGpio *InstancePtr, unsigned Channel);
		dip_check = XGpio_DiscreteRead(&dip, 1);
		psb_check = XGpio_DiscreteRead(&push, 1);

		dip_check_A = dip_check & 0x3;
		dip_check_B = (dip_check & 0xC) >> 2;

		if(psb_check == 0x0){ // "+"
			ok = 0;
			res = dip_check_A + dip_check_B;
			xil_printf("Partial result after addition %d = %d\r\n", dip_check, res);
			LED_IP_mWriteReg(XPAR_LED_IP_0_S_AXI_BASEADDR, 0, res);
		}else if(psb_check == 0x1){ // "-"
			ok = 0;
			res = dip_check_A - dip_check_B;
			xil_printf("Partial result after subtraction %d = %d\r\n", dip_check, res);
			LED_IP_mWriteReg(XPAR_LED_IP_0_S_AXI_BASEADDR, 0, res);
		}else if(psb_check == 0x2){ // "*"
			....
		}else if(psb_check == 0x3){ // "/"
			...
		}
	}
	xil_printf("Exiting from Lab3a calculator!\n");

	return 0;